		<cfif not len(trim(form.zipFile))>
			<cfoutput><strong>Error:</strong> No Zip file specified</cfoutput>
			<cfabort>
		</cfif>
		<cfoutput><b>Uploading zip file...</b></cfoutput>
		<cfflush>
		<cffile action="upload"
			filefield="zipFile"
			destination="#application.defaultFilePath#"
			accept="application/zip,application/vnd.sun.xml.writer,application/octet-stream"
			nameconflict="#application.config.general.fileNameConflict#">
		
		<cfoutput><span class="success">Done<br></span></cfoutput>
		<cfset zipFilePath = application.defaultFilePath & "/" & file.serverFile />
		<cfoutput><strong>Checking if file was uploaded ok...</strong></cfoutput>
		<cfif fileexists(zipFilePath)>
			<cfoutput><span class="success">Done<br></span></cfoutput>
		<cfelse>
			<cfoutput><strong>Error:</strong> File not uploaded. Check permissions on the upload folder.<br />
			Upload folder is: #application.defaultFilePath#
			</cfoutput>
			<cfabort>
		</cfif>
		<cfoutput><strong>Retrieving XML from Open Office document...</strong></cfoutput>
		<cfflush>

		<cfscript>
		
		zipFile = createObject("java", "java.util.zip.ZipFile");
		InputStream = createObject("java", "java.io.InputStreamReader");
		BufInStream = createObject("java", "java.io.BufferedReader");
		xmlcontent = "";
		//open zipFile
		zipFile.init(zipFilePath);
		entries = zipFile.entries();
		while(entries.hasMoreElements()) {
			entry = entries.nextElement();
			if(NOT entry.isDirectory()) {
				nm = entry.getName();
				lenPth = len(nm) - len(getFileFromPath(nm));
				if(nm eq "content.xml") {
					// read in text file
					BufInStream.init(InputStream.init(zipFile.getInputStream(entry)));
					thisLine = BufInStream.readLine();
					while(isDefined('thisLine')) {
						xmlcontent = xmlcontent & thisLine & chr(13)& chr(10);
						thisLine = BufInStream.readLine();
					}
				}
			}
		}


		zipFile.close();
		</cfscript>
		<cfif isdefined("xmlcontent")>
			<cfoutput><span class="success">Done</span><br></cfoutput>
		<cfelse>
			<cfoutput><span class="fail">Unable to retrieve XML from Open Office document.</span><br></cfoutput>
		<cfflush>
		</cfif>
		<!--- Cleanup the uploaded zip file --->
		<cfoutput><span class="success"><strong>Deleting the uploaded file from the server...</strong></span></cfoutput>
		<cffile action="delete" file="#zipFilePath#">
		<cfoutput><span class="success">Done.</span><br></cfoutput>

<cfset wordXml = replaceNoCase(xmlcontent,"<!DOCTYPE office:document-content PUBLIC ""-//OpenOffice.org//DTD OfficeDocument 1.0//EN"" ""office.dtd"">","") />

<cfset parsedWordXml = xmlparse(wordXml) />

<cfset docBody = xmlsearch(parsedWordXml,"/office:document-content/office:body/*") />

<cfset request.htmlbody = "" />

<cfoutput>
<!--- Loop thru the parsed XML array and create a new array containing just headings with HTML as a sub-structure. --->
<cfset items = arrayNew(1) />
<cfloop from="1" to="#arraylen(docBody)#" index="i">

	<cfswitch expression="#docBody[i].xmlName#">
		<cfcase value="text:h">
			<cfscript>
				/* if this is not the first page, 
				create new structures for nav and html object  */
				if (isdefined("item")) {
				arrayAppend(items, item);}
				/* Initialise the nav structures */
				item = structNew();
				item.title = docBody[i].XmlText;
				item.level = docBody[i].XmlAttributes['text:level'];
				item.objectid = createuuid();
				item.parentid = '';
				item.status = status;
				item.ExternalLink = '';
				item.target = '';
				item.options = '';
				item.label = item.title;
				item.createdby = createdBy;
				item.datetimecreated = now();
				item.datetimelastupdated = now();
				item.lastupdatedby = createdBy;

					/* Initialise the html structures to go inside the nav */
					item.htmlItem = structNew();
					item.htmlItem.body = '';
					item.htmlItem.aObjectIDs = arrayNew(1);
					item.htmlItem.aRelatedIDs = arrayNew(1);
					item.htmlItem.aTeaserImageIDs = arrayNew(1);
					item.htmlItem.body = "";
					item.htmlItem.commentLog = "";
					item.htmlItem.createdBy = createdBy;
					item.htmlItem.datetimecreated = now();
					item.htmlItem.datetimelastupdated = now();
					item.htmlItem.displayMethod = "";
					item.htmlItem.title = item.title;
					item.htmlItem.label = item.title;
					item.htmlItem.lastUpdatedBy = createdBy;
					item.htmlItem.metaKeywords = "";
					item.htmlItem.objectID = createUUID();
					item.htmlItem.status = status;
					item.htmlItem.teaser = "";
					item.htmlItem.typeName = "";
					item.htmlItem.versionID = "";
					item.htmlItem.extendedMetaData = "";
				
				/* Associate this nav with this page */
				item.aObjectIDs = arrayNew(1);
				item.aObjectIDs[1] = item.htmlitem.objectID;

			</cfscript>
			<!---
			<cfset indentLevel = item.level - 1 />
			--->
			<p>#RepeatString("&nbsp;-&nbsp;", item.level-1)# #docBody[i].XmlText#</p>
		</cfcase>
		<cfcase value="text:p">
			<cfset stHtmlHeading = refind("^[hH]([123456]):",trim(docBody[i].xmltext),1,true) />
			<cfif stHtmlHeading.len[1] gt 0>
			<cfscript>
				sParagraph = trim(docBody[i].xmltext); 
				htmlHeadingType = mid(sParagraph,stHtmlHeading.pos[2],stHtmlHeading.len[2]);
				htmlHeadingText = trim(mid(sParagraph,4,len(sParagraph)-3));
				request.htmlbody = "<h" & htmlHeadingType & ">" & htmlHeadingText & "</h" & htmlHeadingType & ">";
			</cfscript>
			<cfelseif left(trim(docBody[i].xmltext),1) eq "<">
				<cfset request.htmlbody = trim(docBody[i].xmltext) />
			<cfelse>
				<cfset request.htmlbody = application.parseWordXml.parseParagraph(xmlStruct=docBody[i]) />
			</cfif>		
		</cfcase>
		<cfcase value="table:table">
			<cfset request.htmlbody = application.parseWordXml.parseTable(xmlStruct=docBody[i]) />
		</cfcase>
		<cfcase value="text:unordered-list">
			<cfset request.htmlbody = application.parseWordXml.parseUl(xmlStruct=docBody[i]) />
		</cfcase>
		<cfcase value="text:ordered-list">
			<cfset request.htmlbody = application.parseWordXml.parseOl(xmlStruct=docBody[i]) />
		</cfcase>
		
		<cfcase value="text:sequence-decls,text:sequence-decl">
			<!--- come back to support for this? --->
		</cfcase>
		<cfdefaultcase>
			<cfscript>
				request.htmlbody = '<p><strong>' & #docBody[i].xmlName# &' to be added.</strong></p>';
			</cfscript>
			<p>Support for #docBody[i].xmlName# later</p>
		</cfdefaultcase>
	</cfswitch>
	<cfscript>
	
	if (isdefined("item.htmlItem.body") and len(request.htmlbody) gt 0) {
		item.htmlItem.body = item.htmlItem.body & request.htmlbody & request.cr ;
		request.htmlbody = "";
		}
	
	</cfscript>
</cfloop>
</cfoutput>
<cfif docBody[arrayLen(docBody)].xmlName neq "text:h">
	<cftry>
	<cfset tmp = arrayAppend(items, item) />
		<cfcatch>
			<cfoutput><h2>Error: There was no headings in the document</h2></cfoutput>
			<cfabort>
		</cfcatch>
	</cftry>
</cfif>
<cfscript>
// Fix levels: if there's a heading 1 followed by a heading 6 make it 1->2
for (i = 2; i lte arraylen(items); i = i + 1) {

	if (items[i].level - items[i-1].level gt 1) {
	items[i].level = items[i-1].level + 1;
	}

}

// now figure out each item's parent node
	parentstack = arrayNew(1);
	navstack = arrayNew(1);
	arrayAppend(parentstack, startPoint);
	lastlevel = 0;
	for (i = 1; i lte arraylen(items); i = i + 1) {
			
		if (items[i].level lt lastlevel) {
			diff = lastlevel - items[i].level;
			for (j = 0; j lte diff; j = j + 1) {
				arrayDeleteAt(parentstack, arraylen(parentstack));
				arrayDeleteAt(navstack, arraylen(navstack));
			}
		}
		else if (items[i].level eq lastlevel) {
			arrayDeleteAt(parentstack, arraylen(parentstack));
			arrayDeleteAt(navstack, arraylen(navstack));
		}

		items[i].parentid = parentstack[arraylen(parentstack)];

		arrayAppend(parentstack, items[i].objectid);

		navtitle = lcase(rereplacenocase(items[i].title, "\W+", "_", "all"));
		arrayAppend(navstack, rereplace(navtitle, "_+", "_", "all"));

		if (makenavaliases) {
			if (navaliaseslevel eq 0 or items[i].level lte navaliaseslevel)
				items[i].lNavIDAlias = arrayToList(navstack, '_');
			else
				items[i].lNavIDAlias = '';
		}
		else
			items[i].lNavIDAlias = '';
			lastlevel = items[i].level;
	}
	
</cfscript>